#pragma once
#include "NScrollBar.h"
#include "ScrollBarUI_Img.h"
#include "ScrollBarUI_Solid.h"
#include "ScriptletContainerFactory.h"

class NPCOMMONUI_API CNScrollView	: public CNControl
									, public IMouseListener
									, public IScrollListener
{
public:
	DECLARE_COMPONENT_CREATOR(CNScrollView);
	CNScrollView();
	virtual ~CNScrollView();

	DECLARE_RTTI

	//overrride
	//CComponent
	LPCTSTR GetClassName() { return SCRIPTLET_SCROLLVIEW_NODE; }
	void OnCreate();
	void OnDestroy();
	BOOL GetClientRect(LPRECT lpRect);
	void OnAddChild(CComponent* pChild);
	void OnRemoveChild(CComponent* pChild);
	//IMouseListener
	void	OnMousePressed(CMouseEvent* pMouseEvent) {}
	void	OnMouseReleased(CMouseEvent* pMouseEvent) {}
	void	OnMouseEntered(CMouseEvent* pMouseEvent);
	void	OnMouseExited(CMouseEvent* pMouseEvent);
	void	OnMouseMoved(CMouseEvent* pMouseEvent) {}
	void	OnMouseWheelMoved(CMouseEvent* pMouseEvent) {}
	//IScrollListener
	void	OnHScroll(CScrollEvent* pScrollEvent);
	void	OnVScroll(CScrollEvent* pScrollEvent);
	
	void AddScrollBar( CScrollBarUI_Img::PSCROLLBARUI_INFO pInfoHorz, CScrollBarUI_Img::PSCROLLBARUI_INFO pInfoVert );

	void GetScrollInfo(LPSCROLLINFO pSi, BOOL bHorz);
	void SetScrollInfo(LPSCROLLINFO pSi, BOOL bHorz);
	void AddScrollListener(IScrollListener* pListener);
	void RemoveScrollListener(IScrollListener* pListener);

	void SetWheelHop(int nWheelHop);
	int GetWheelHop();
	void SetLineHop(int nLineHop);
	int GetLineHop();

	void UpdateScrollInfo();

	VBEGIN_MSG_MAP(CNScrollView)
		MESSAGE_HANDLER(WM_MOUSEWHEEL, OnMouseWheel)

		CHAIN_MSG_MAP(CContainer)
	END_MSG_MAP()

	DECLARE_MESSAGE_HANDLER(OnMouseWheel);
protected:
//override	
	BOOL _GetScrollPos(LPPOINT ppt);
	void OnSize(INT32 nWidth, INT32 nHeight);

private:
	void _Update_Layout_ScrollBars();
	
	CAutoPtr<CNScrollBar> m_pScrollBarHorz;
	CAutoPtr<CScrollBarUI_Img> m_pScrollBarUI_Img_Horz;

	CAutoPtr<CNScrollBar> m_pScrollBarVert;
	CAutoPtr<CScrollBarUI_Img> m_pScrollBarUI_Img_Vert;

	int m_nWheelHop;
	int m_nLineHop;

	CComponent* m_pFocusedComponent_Old;
};